@make(ais)
@aiInfo(topic=<Secondary units as implicit specifications>,
number=[AI-00855/00],
classcode=[ST],
statuscode=[RE],
mainref=[10.01@\(06)],
date=[89-12-11])
@aiHeading()
@begin(history)
@begin(toplines)
@mainref()
@cbon()!class study 89-12-11
!status received 89-12-11
@end(toplines)
@topic{!topic Secondary units as implicit specifications}
@end(history)

@subheading[!summary 89-12-11]


@subheading[!question 89-12-11]


@subheading[!recommendation 89-12-11]


@subheading[!discussion 89-12-11]


@begin(appendix)
@subheading[!appendix 89-10-24]
@begin(sectionGroup)
@mybar()

!section 10.01    (06)    Erhard Ploedereder    89-10-24            83-01316
!version 1983
!topic Secondary units as implicit specifications
@end(sectionGroup)

!summary
The notion of 10.01 (6) that a secondary unit without previously
specification acts both as a library unit and secondary unit should be
altered to make these implicit specifications "first-class citizens", so
that compilation of such a subprogram declaration creates both a library and
a secondary unit.

!rationale
The current semantics of 10.01 (6) introduces a "wart" in the library
concept. In connection with obsolescence rules, it leads to unnecessary
recompilations. Consider the compilation sequence

    procedure foo is begin ...-- 1. body
                     end foo;
    with foo;
    package Q is ... end Q;

    procedure foo is begin ...-- 2. body
                     end foo;

Here, the rules of 10.3 (seem to) require that Q is now obsolete,
although there is obviously no good reason for it. (There are ACVC
checks of this ilk, despite the last sentence of 10.3(5).)

If one always required separately compiled specifications or, better,
specified the semantics of compiling secondary units without previous
specifications as implicitly generating such specifications (rather
than serving both as library and secondary units), these problems and
user inconveniences would disappear.

@end(appendix)
@cboff()
